// Copyright Thomas Andrews, 1996
//
// All non-commercial use of this code is permitted
// as long as this copyright notice is maintained.
//
#include "Choose.H"

ChooseTable::ChooseTable(unsigned int n, unsigned int k) : _n(n)
{
    int col=1,row;
    N=new (Integer *)[n+1];
    for (row=0; row<=n; row++) {
        int width=(row<=k ? (row) : (k));
	N[row]=new Integer[width+1];
	N[row][0]=1;
	if (row<=k) { 
		N[row][width]=1;
	} else {
		N[row][width]=N[row-1][width]+N[row-1][width-1];
        }
        for (col=1; col<width; col++) {
		N[row][col]=N[row-1][col]+N[row-1][col-1];
	}
    }
}


ChooseTable::~ChooseTable()
{
	int row;
	for (row=0; row<=_n; row++) {
		delete [] N[row];
	}
	delete [] N;
}

const Integer ChooseTable::zero=0;
