//
// Copyright 1996, Thomas Andrews (thomaso@best.com)
// Free for non-commercial use
//
#include <string.h>
#include "Deal.H"

/* 
 *
 *	The ChooseTable is just a fast choose function.
 *	Rather gross, actually.  Once created, it acts
 *	like a function, so that we can call Choose(n,k).
 *      The object just states the limits to which we expect
 *	to call it.
 */
ChooseTable Choose(53,13);

/*
 *	The template class, "tDeal", can be used with other
 *	sizes.  Used templates instead of parameters for
 *      faster computations.
 *
 */
typedef class tDeal<13,4> Deal;

/*
 * 	"encode" loops through the input, expecting deals of the form:
 * 		0222101010113301333030322203212103020113233311212002
 *	and writes out the deal's index.
 *
 *	Not graceful on bad input
 */
void encode () {
     char buffer[2000];
     while (cin>>buffer) {
             Deal deal(buffer);
             Integer dealno=Integer(deal);
             cout << dealno << endl;
     }
}

/*
 *	"decode" loops through the input, expecting index values,
 *	and writes out the deal in the form noted for "encode."
 *
 *      Not graceful on bad input
 */
void decode () {
     //static const Integer MaxDealNo=numberofdeals(13);
     Integer dealno;
     while (cin>>dealno) {
             Deal deal(dealno);
	     deal.write(cout) << endl;
     }
}

/* Gross kluge to put "encode" and "decode" function into one binary */
main (int argc, char **argv) {
	char *basename=strrchr(argv[0],'/');
        if (basename==0) {
		basename=argv[0];
	} else {
		basename++;
	}

	if (basename[0]=='e') {
		encode();
        } else {
		decode();
	}
        return 0;
}
